# spec file for package openafs (Version 1.4.x)
#
# Copyright (c) 2006 SUSE LINUX Products GmbH, Nuernberg, Germany.
# This file and all modifications and additions to the pristine
# package are under the same license as the package itself.
#
# Please submit bugfixes or comments via http://bugs.opensuse.org
#

#norootforbuild


#
#	TUNABLES
#


#
# define distribution and version
#

%define suse_version 1140

#kerberos5
# 0=MIT | 1=Heimdal
%define		option_heimdal		0

# clean build-root after build
%define		option_clean_buildroot	0

# don't build kdump?
# probably does not work on Linux atm.
%define		option_dontbuild_kdump	0

# build largefile fileserver
%define		option_largefile	1

# build authlibs
%define build_authlibs 1

# build modules
%define build_modules 1

# filesystem layout transarc or fsh
%define transarc_paths 0

# create PAM libraries
%define build_pamlibs 1

# enable OSD-support
%define osd_support 0

#
# auto-determined parameters
#
%if %{transarc_paths} == 1

%define pamdir            /%{_lib}/security
%define libdir            %{_libdir}
%define libexecdir        %{_libdir}
%define bindir            %{_bindir}
%define sbindir           %{_sbindir}
%define includedir        %{_includedir}/afs
%define mandir            %{_mandir}
%define sysconfdir        %{_sysconfdir}
%define usrafsdir         /usr/afs
%define afsconfdir        %{usrafsdir}/etc
%define afslogsdir        %{usrafsdir}/logs
%define afslocaldir       %{usrafsdir}/local
%define afsbindir         %{usrafsdir}/bin
%define afsbackupdir      %{usrafsdir}/backup
%define afsbosconfigdir	  %{usrafsdir}/local
%define afsdbdir	  %{usrafsdir}/db
%define afssrvbindir	  %{usrafsdir}/bin
%define afssrvlibexecdir  %{usrafsdir}/bin
%define afssrvsbindir	  %{usrafsdir}/bin
%define afslibdir         %{_libdir}/afs
%define vicedir           /usr/vice
%define viceetcdir        %{vicedir}/etc
%define vicecachedir      %{viceetcdir}/cache	
%define afskerneldir	  %{viceetcdir}/etc

%else

%define pamdir            /%{_lib}/security
%define libdir            %{_libdir}
%define libexecdir        %{_libdir}
%define bindir            %{_bindir}
%define sbindir           %{_sbindir}
%define includedir        %{_includedir}/openafs
%define mandir            %{_mandir}
%define afslogsdir        /var/log/openafs
%define sysconfdir        %{_sysconfdir}
%define afsconfdir        /etc/openafs/server
%define viceetcdir        /etc/openafs
%define vicecachedir	  /var/cache/openafs
%define afslocaldir       /var/lib/openafs

%endif

#
#conflicting packages with other path-layout
#

%if %{transarc_paths} 
%define OA_Conflicts openafs openafs-client openafs-server openafs-krb5-mit openafs-krb5-heimdal openafs-authlibs-devel openafs-authlibs openafs-docs openafs-kernel-source openafs-devel openafs-kmp-trace openafs-kmp-xen openafs-kmp-pae openafs-kmp-default 
%if %{osd_support}
Name:         openafs-osd-transarc
%else
Name:         openafs-transarc
%endif
%else
%define OA_Conflicts openafs-transarc openafs-transarc-client openafs-transarc-server openafs-transarc-krb5-mit openafs-krb5-heimdal openafs-transarc-authlibs-devel openafs-transarc-authlibs openafs-transarc-docs openafs-transarc-kernel-source openafs-transarc-devel openafs-transarc-kmp-trace openafs-transarc-kmp-xen openafs-transarc-kmp-pae openafs-transarc-kmp-default 
%if %{osd_support}
Name:         openafs-osd
%else
Name:         openafs
%endif
%endif

Version:      1.4.14.1
Release:      15.2
Summary:      OpenAFS Distributed File System
License:      IBM Public License
URL:          http://www.openafs.org/
Group:        System/Filesystems
Conflicts:    %{OA_Conflicts}
Autoreqprov:  on
%if %{_vendor} == "suse" 
PreReq:       %insserv_prereq %fillup_prereq 
%endif

Source0:      openafs-%{version}-src.tar.bz2
Source1:      openafs-%{version}-doc.tar.bz2
Source10:     README.SuSE.openafs
Source11:     rc.afs-server
Source12:     rc.afs-client
Source13:     sysconfig.openafs-client
Source14:     sysconfig.openafs-server
Source17:     README.SuSE.openafs_spec
Source18:     ChangeLog
Source20:     Makefile.kernel-source
Source54:     openafs.CellServDB
Source55:     openafs.SuidCells
Source56:     openafs.CellAlias
Source57:     openafs.ThisCell
Source58:     openafs.cacheinfo
Source99:     openafs.changes
Patch100:       openafs-1.4.x.layout.patch
Patch23:      openafs-1.4.x-no-kdump.patch
Patch24:      openafs-1.4.x.compiler-warnings.patch
#Patch25:      openafs-1.4.x.64bitLinker-makefile.patch
Patch26:      openafs-1.4.x.rpmlint.patch
Patch27:      openafs-1.4.x.64bit-warnings.patch
Patch28:      openafs-1.4.x.pic.patch
Patch29:      openafs-1.4.x.DEBUG.patch
BuildRoot:    %{_tmppath}/%{name}-%{version}-build

#
#	GENERAL BuildRequires and Requires
#

BuildRequires:  pam-devel, ncurses-devel, flex, bison

%if %{_vendor} == "suse"
 %ifarch ppc64
BuildRequires:  pam-devel-64bit
 %endif
%endif

%if %{_vendor} == "suse"
  %if 0%{?sles_version} == 9 
BuildRequires: heimdal, heimdal-devel, heimdal-tools, heimdal-lib, openssl-devel
    %define option_heimdal 1
    %define build_modules 1
    %if %{_arch} == "i586"
        %define ARCH i386
    %else
        %define ARCH %{_arch}
    %endif
  %else # not SLES_9
    %define option_heimdal 0
    %define ARCH %{_arch}
    %if 0%{?sles_version} == 10
BuildRequires:  krb5-devel	
    %else # not SLE_10
BuildRequires:  krb5-devel, fdupes
    %endif
  %endif
  %if %{option_heimdal} 
    %define krb5_config /usr/lib/heimdal/bin/krb5-config
  %else 
    %define krb5_config /usr/lib/mit/bin/krb5-config
  %endif
%endif

%if %{_vendor} == "mandriva" 
BuildRequires: krb5-devel
  %define krb5_config /usr/bin/krb5-config
  %define build_modules 0
  %define ARCH %{_arch}
%endif

%if %{_vendor} == "redhat"
BuildRequires: krb5-devel
  %define krb5_config /usr/kerberos/bin/krb5-config
  %define build_modules 0
  %define ARCH %{_arch}
  %if 0%{?fedora_version} == 10 
    # TEMPORARY fix for patch fuzz so we can build on Fedora 10
    %define _default_patch_fuzz 2
  %endif
%endif

%if %{build_modules} 
  %if %{_vendor} == "suse" 
BuildRequires: kernel-syms module-init-tools kernel-source
  %endif
  %if %{_vendor} == "redhat" 
BuildRequires: kernel-devel
  %endif
%endif


%description  
AFS is a cross-platform distributed file system product pioneered at
Carnegie Mellon University and supported and developed as a product by
Transarc Corporation (now IBM Pittsburgh Labs). It offers a
client-server architecture for file sharing, providing location
independence, scalability, and transparent migration capabilities for
data.

In addition, among its features are authentication, encryption,
caching, disconnected operations, replication for higher availability
and load balancing, and ACLs.

Authors:
--------
    see http://www.openafs.org/credits.html

%package client
Summary:      OpenAFS File System Client
Group:        System/Filesystems
Requires:     %{name} = %{version}, coreutils, sed, grep, diffutils, fillup 
Conflicts:    %{OA_Conflicts}

%description client
AFS is a cross-platform distributed file system product pioneered at
Carnegie Mellon University and supported and developed as a product by
Transarc Corporation (now IBM Pittsburgh Labs). It offers a
client-server architecture for file sharing, providing location
independence, scalability, and transparent migration capabilities for
data.

In addition, among its features are authentication, encryption,
caching, disconnected operations, replication for higher availability
and load balancing, and ACLs. This package contains the OpenAFS client.

Authors:
--------
    see http://www.openafs.org/credits.html

%package server
Summary:      OpenAFS File System Server
Group:        System/Filesystems
Requires:     %{name} = %{version}
Conflicts:    %{OA_Conflicts}

%description server
AFS is a cross-platform distributed file system product pioneered at
Carnegie Mellon University and supported and developed as a product by
Transarc Corporation (now IBM Pittsburgh Labs). It offers a
client-server architecture for file sharing, providing location
independence, scalability, and transparent migration capabilities for
data.

In addition, among its features are authentication, encryption,
caching, disconnected operations, replication for higher availability
and load balancing, and ACLs. This package contains the static
libraries and header files needed to develop applications for OpenAFS.

Authors:
--------
    see http://www.openafs.org/credits.html

%package authlibs
Summary: OpenAFS authentication shared libraries
Group: System/Filesystems

%if %{build_authlibs}
%description authlibs
The AFS distributed filesystem.  AFS is a distributed filesystem
allowing cross-platform sharing of files among multiple computers.
Facilities are provided for access control, authentication, backup and
administrative management.

This package provides a shared version of libafsrpc and libafsauthent.
None of the programs included with OpenAFS currently use these shared
libraries; however, third-party software that wishes to perform AFS
authentication may link against them.
%endif

%package authlibs-devel
Summary: OpenAFS shared library development
Group: Development/Libraries/C and C++
%if %{build_authlibs}
Requires: %{name}-authlibs = %{version}
%endif
Requires: %{name}-devel = %{version}

%description authlibs-devel
The AFS distributed filesystem.  AFS is a distributed filesystem
allowing cross-platform sharing of files among multiple computers.
Facilities are provided for access control, authentication, backup and
administrative management.

This package includes the static versions of libafsrpc and
libafsauthent, and symlinks required for building against the dynamic
libraries.

%package devel
Summary:      OpenAFS Static Libraries and Header Files
Group:        Development/Libraries/C and C++
Requires:     %{name} = %{version} 
Conflicts:    %{OA_Conflicts}

%description devel
AFS is a cross-platform distributed file system product pioneered at
Carnegie Mellon University and supported and developed as a product by
Transarc Corporation (now IBM Pittsburgh Labs). It offers a
client-server architecture for file sharing, providing location
independence, scalability, and transparent migration capabilities for
data.

In addition, among its features are authentication, encryption,
caching, disconnected operations, replication for higher availability
and load balancing, and ACLs. This package contains the OpenAFS server.

Authors:
--------
    see http://www.openafs.org/credits.html

%package docs
Summary: OpenAFS user and administrator documentation
Requires: %{name} = %{version}
Group: System/Filesystems

%description docs
The AFS distributed filesystem.  AFS is a distributed filesystem
allowing cross-platform sharing of files among multiple computers.
Facilities are provided for access control, authentication, backup and
administrative management.

This package provides HTML documentation for OpenAFS users and system
administrators.

%package kernel-source
Summary: OpenAFS Kernel Module source tree
Group: System/Filesystems
Provides: %{name}-kernel = %{version}

%description kernel-source
The AFS distributed filesystem.  AFS is a distributed filesystem
allowing cross-platform sharing of files among multiple computers.
Facilities are provided for access control, authentication, backup and
administrative management.

This package provides the source code to build your own AFS kernel
module.

%if %{option_heimdal}
%package krb5-heimdal
Summary: OpenAFS programs to use with krb5
Requires: %{name} = %{version}
Group: System/Filesystems
Requires: heimdal-lib heimdal-tools

%description krb5-heimdal
The AFS distributed filesystem.  AFS is a distributed filesystem
allowing cross-platform sharing of files among multiple computers.
Facilities are provided for access control, authentication, backup and
administrative management.

This package provides compatibility programs so you can use krb5
to authenticate to AFS services, instead of using AFS's homegrown
krb4 lookalike services.
This is using the  implementation of krb5.
Requires: heimdal-lib heimdal-tools
%else 

%package krb5-mit
Summary: OpenAFS programs to use with krb5
Requires: %{name} = %{version}
Group: System/Filesystems
Requires : krb5   

%description krb5-mit
The AFS distributed filesystem.  AFS is a distributed filesystem
allowing cross-platform sharing of files among multiple computers.
Facilities are provided for access control, authentication, backup and
administrative management.

This package provides compatibility programs so you can use krb5
to authenticate to AFS services, instead of using AFS's homegrown
krb4 lookalike services.
This is using the MIT implementation of krb5.

%endif

%if %{build_modules}
%package KMP
Summary:        OpenAFS Distributed File System - kernel module
Group:          System/Kernel
Conflicts:    %{OA_Conflicts}
%if 0%{?sles_version} != 9
%suse_kernel_module_package lockdep um
%endif

%description KMP
This package contains the kernel module for OpenAFS. For details see
the openafs package.

Authors:
--------
    see http://www.openafs.org/credits.html

%endif

%prep

: @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
: @@@
: @@@ package-name:       %{name}
%if %{transarc_paths}
: @@@ file-layout:	  transarc
%else
: @@@ file-layout:	  fsh
%endif
%if %{osd_support}
: @@@ OSD support enabled
%else
: @@@ OSD support disabled
%endif
: @@@ PAM modules dir:    %{pamdir}
: @@@ lib dir:    	  %{libdir}
: @@@ libexec dir:    	  %{libexecdir}
: @@@ bin dir:    	  %{bindir}
: @@@ sbin dir:    	  %{sbindir}
: @@@ include dir:    	  %{includedir}
: @@@ sysconf dir:    	  %{sysconfdir}
: @@@ man dir:    	  %{mandir}
: @@@ build modules:      %{build_modules}
%if %{option_heimdal}
: @@@ krb5 : heimdal
%else
: @@@ krb5 : mit
%endif
: @@@ ARCH:               %{ARCH}
: @@@ target cpu:         %{_target_cpu}
: @@@
: @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@


%setup -q -n openafs-%{version} -T -b 0 -b 1

if [ "x$(which fdupes 2> /dev/null)" = "x" ]; then
   touch %{_sourcedir}/fdupes
   chmod 555 %{_sourcedir}/fdupes
else
   ln -s $(which fdupes) %{_sourcedir}/fdupes
fi

cp src/config/param.ppc64_linux24.h src/config/param.ppc64_linux26.h
cp src/config/param.s390_linux24.h src/config/param.s390_linux26.h
#

%if %{option_dontbuild_kdump} == 1
%patch23
%endif

%patch24 -p1
#%patch25 -p1
%patch26 -p1
%patch27
%patch28 -p1
%patch29 -p1

%if %{transarc_paths} == 0
%patch100 -p1
%endif


%if %{option_heimdal}
sed -i -e "s/ASETKEY=asetkey/ASETKEY=/" src/cf/kerberos.m4
%endif
./regen.sh


%build
sysbase=%{ARCH}
%ifarch %ix86
	sysbase=i386
%endif
%ifarch ppc
	perl -pi -e 's,^(XCFLAGS.*),\1 -fPIC,' src/config/Makefile.ppc_linux24.in
%endif
%ifarch ppc64
	sysbase=ppc64
%endif
%ifarch s390x
	sysbase=s390
%endif
%ifarch x86_64
	sysbase=amd64
	perl -pi -e 's,^(XCFLAGS.*),\1 -fPIC,' src/config/Makefile.amd64_linux24.in
	perl -pi -e 's,^(XLIBS.*),\1 -lresolv,' src/config/Makefile.amd64_linux24.in
%endif
afs_sysname=${sysbase}_linux26
# there are mixed static and shared libs, using -fPIC everywhere is the most safe.
#

RPM_OPT_FLAGS=`echo ${RPM_OPT_FLAGS} | sed s/-D_FORTIFY_SOURCE=2//`
export CFLAGS="$RPM_OPT_FLAGS -fno-strict-aliasing -fPIC" 

%if %{option_heimdal}
export CFLAGS="$CFLAGS -I/usr/include/heimdal" 
%else
export KRB5LIBS='-lcom_err -lkrb5'
%endif

%ifarch ppc64
export LDFLAGS="$LDFLAGS -m64"
%endif

# 
# we need to build it twice: once with debug and once without
# phase 1 : build debug-binaries

./configure \
		--prefix=/usr \
%if %{transarc_paths} == 0
		--disable-transarc-paths \
%else 
                --enable-transarc-paths \
%endif
%if %{build_pamlibs} == 0
               --disable-pam \
%endif
		--bindir=%{bindir} \
		--sbindir=%{sbindir} \
		--libdir=%{libdir} \
		--libexecdir=%{libexecdir} \
		--includedir=%{includedir} \
		--sysconfdir=%{sysconfdir} \
		--mandir=%{mandir} \
		--with-krb5-conf=%{krb5_config} \
%if %{option_largefile}
		--enable-largefile-fileserver \
%endif
%if %{osd_support}
		--enable-object-storage \
%endif
		--with-afs-sysname=$afs_sysname \
		--disable-kernel-module \
		--enable-bos-restricted-mode \
		--enable-bos-new-config \
		--enable-debug \
		--enable-debug-lwp \
		--disable-optimize \
		--disable-optimize-lwp

%if %{osd_support}
 make all_nolibafs
%else
 make CCFLAGS="$CFLAGS" XCFLAGS="$CFLAGS" PAM_CFLAGS="$CFLAGS" KOPTS="$CFLAGS" all_nolibafs
%endif

mkdir DEBUG
mkdir -p DEBUG/etc
mkdir -p DEBUG/etc/init.d/
mkdir -p DEBUG/%{libdir}/
mkdir -p DEBUG/%{includedir}
mkdir -p DEBUG/%{afslogsdir}
mkdir -p DEBUG/%{mandir}
%if %{build_pamlibs}
mkdir -p DEBUG/%{pamdir}
%endif
mkdir -p DEBUG/%{bindir}

make DESTDIR=`pwd`/DEBUG install_nolibafs

#
# phase 2 : build optimized binaries

./configure \
		--prefix=/usr \
%if %{transarc_paths} == 0
		--disable-transarc-paths \
%else 
                --enable-transarc-paths \
%endif
%if %{build_pamlibs} == 0
               --disable-pam \
%endif
		--bindir=%{bindir} \
		--sbindir=%{sbindir} \
		--libdir=%{libdir} \
		--libexecdir=%{libexecdir} \
		--includedir=%{includedir} \
		--sysconfdir=%{sysconfdir} \
		--mandir=%{mandir} \
		--with-krb5-conf=%{krb5_config} \
%if %{option_largefile}
		--enable-largefile-fileserver \
%endif
%if %{osd_support}
		--enable-object-storage \
%endif
		--with-afs-sysname=$afs_sysname \
		--disable-kernel-module \
		--enable-bos-restricted-mode \
		--enable-bos-new-config 

%if %{osd_support}
 make all_nolibafs
 make only_libafs_tree
%else
 make CCFLAGS="$CFLAGS" XCFLAGS="$CFLAGS" PAM_CFLAGS="$CFLAGS" KOPTS="$CFLAGS" all_nolibafs
 make CCFLAGS="$CFLAGS" XCFLAGS="$CFLAGS" PAM_CFLAGS="$CFLAGS" KOPTS="$CFLAGS" only_libafs_tree
%endif


# the test suite need a configured KDC
#make -C src/tests all

# Kernel-module
%ifarch  %ix86
	export EXTRA_CFLAGS=$CFLAGS
	unset CFLAGS
%endif

%if %{build_modules}
mkdir obj

%if 0%{?sles_version} == 9
%if %{ARCH} == "x86_64"
%define flavors_to_build default smp
%else
%define flavors_to_build default smp bigsmp
%endif
%endif

for flavor in %flavors_to_build; do
    rm -rf obj/$flavor
    cp -a libafs_tree obj/$flavor
    pushd obj/$flavor
    ./configure --with-linux-kernel-build=/usr/src/linux-obj/%{ARCH}/$flavor --with-linux-kernel-headers=/usr/src/linux \
%if %{osd_support}
		--enable-object-storage \
%endif
%if %{transarc_paths} == 0
		--disable-transarc-paths
%else 
                --enable-transarc-paths
%endif
    make
    popd
done
%endif

%install
if [ -n "$RPM_BUILD_ROOT" ] ; then
   [ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT
fi

#
mkdir ${RPM_BUILD_ROOT}
#
mkdir $RPM_BUILD_ROOT/etc
mkdir -p $RPM_BUILD_ROOT/etc/init.d/
mkdir -p $RPM_BUILD_ROOT/%{libdir}/
mkdir -p $RPM_BUILD_ROOT/%{includedir}
mkdir -p $RPM_BUILD_ROOT/%{afslogsdir}
mkdir -p $RPM_BUILD_ROOT/%{mandir}
%if %{build_pamlibs}
mkdir -p $RPM_BUILD_ROOT/%{pamdir}
%endif
mkdir -p $RPM_BUILD_ROOT/%{bindir}

make DESTDIR=$RPM_BUILD_ROOT install_nolibafs

# copy DEBUG-static-libs
OLD_PWD=`pwd`
cd DEBUG
for f in `find . -name *\.a`; do
   cp $f ${RPM_BUILD_ROOT}/$f
done
cd $OLD_PWD

# config & startup files
install -m 755 $RPM_SOURCE_DIR/rc.afs-server $RPM_BUILD_ROOT/etc/init.d/openafs-server
install -m 755 $RPM_SOURCE_DIR/rc.afs-client $RPM_BUILD_ROOT/etc/init.d/openafs-client
ln -s ../../etc/init.d/openafs-server $RPM_BUILD_ROOT/usr/sbin/rcopenafs-server
ln -s ../../etc/init.d/openafs-client $RPM_BUILD_ROOT/usr/sbin/rcopenafs-client

#
# generate man-pages 

OLD_PWD=`pwd`
cd doc/man-pages
make DESTDIR=$RPM_BUILD_ROOT install
cd $OLD_PWD

#
#	common: pam, kpasswd

# conflicts with kpasswd from heimdal package
mv $RPM_BUILD_ROOT/usr/bin/kpasswd $RPM_BUILD_ROOT/usr/bin/kpasswd.afs
mv $RPM_BUILD_ROOT/%{mandir}/man1/kpasswd.1 $RPM_BUILD_ROOT/%{mandir}/man1/kpasswd.afs.1
%if %{build_pamlibs}
  mv %{buildroot}/%{libdir}/pam* %{buildroot}/%{pamdir}
  ln -sf pam_afs.so.1	%{buildroot}/%{pamdir}/pam_afs.so
  ln -sf pam_afs.krb.so.1	%{buildroot}/%{pamdir}/pam_afs.krb.so
%endif

#	common: kernel-source 
mkdir -p $RPM_BUILD_ROOT/usr/src/kernel-modules/openafs
chmod -R o-w src/libafs
chmod -R o-w libafs_tree

#	common: KMP
%if %{build_modules}
  export INSTALL_MOD_PATH=$RPM_BUILD_ROOT
  export INSTALL_MOD_DIR=updates
  %if 0%{?sles_version} == 9
  %if %{ARCH} == "x86_64"
    %define flavors_to_build default smp
  %else
    %define flavors_to_build default smp bigsmp
 %endif
 %endif

  for flavor in %flavors_to_build; do
    make -C /usr/src/linux-obj/%{ARCH}/$flavor modules_install \
         M=$PWD/`find obj/$flavor/ -name MODLOAD-\* -type d`
  done
%endif

# kernel-sources
cp -a libafs_tree $RPM_BUILD_ROOT/usr/src/kernel-modules/openafs
cp -av %{S:20} $RPM_BUILD_ROOT/usr/src/kernel-modules/openafs/Makefile
install -m 644 src/LICENSE $RPM_BUILD_ROOT/usr/src/kernel-modules/openafs/LICENSE
%{_sourcedir}/fdupes -q -r -s $RPM_BUILD_ROOT/usr/src/kernel-modules

# main package
mkdir -p $RPM_BUILD_ROOT/%{mandir}/man5
install -m 644 src/pam/pam_afs.5 $RPM_BUILD_ROOT/%{mandir}/man5
cp -a %{S:10} README.SuSE
cp -a %{S:17} README.SuSE.openafs_spec
cp -a %{S:18} ChangeLog 

# devel package
%{_sourcedir}/fdupes -q -r -s $RPM_BUILD_ROOT/usr/include/openafs
%{_sourcedir}/fdupes -q -r -s $RPM_BUILD_ROOT/usr/%{libdir}/openafs
%{_sourcedir}/fdupes -q -r -s $RPM_BUILD_ROOT/usr/src/kernel-modules/openafs

# krb5
%if %{transarc_paths} == 0
  mv $RPM_BUILD_ROOT%{bindir}/asetkey $RPM_BUILD_ROOT%{sbindir}/asetkey
%endif 

# some pathes cleanup
%if %{transarc_paths} == 0
  mv $RPM_BUILD_ROOT%{bindir}/bos $RPM_BUILD_ROOT%{sbindir}/bos
  mv $RPM_BUILD_ROOT%{bindir}/udebug $RPM_BUILD_ROOT%{sbindir}/udebug
%if %{osd_support}
  mv $RPM_BUILD_ROOT%{libdir}/openafs/localauth $RPM_BUILD_ROOT%{sbindir}/localauth
%endif
%endif

# avoid conflicts with other packages
mv $RPM_BUILD_ROOT/%{_bindir}/scout $RPM_BUILD_ROOT/%{_bindir}/afs_scout
mv $RPM_BUILD_ROOT/%{_mandir}/man1/scout.1 $RPM_BUILD_ROOT/%{_mandir}/man1/afs_scout.1

# remove unused man pages
for x in afs_ftpd afs_inetd afs_login afs_rcp afs_rlogind afs_rsh \
    dkload knfs package runntp symlink symlink_list symlink_make \
    symlink_remove; do
        rm -f $RPM_BUILD_ROOT%{mandir}/man1/${x}.1
done

# compress man pages
OLD_PWD=`pwd`
for d in $RPM_BUILD_ROOT%{_mandir}/man*;do
    cd $d
    for f in *;do
        if [ -h $f ]; then
            mv $f $f.gz
        elif [ -f $f ];then
            gzip -9 $f
        else 
            echo "Unknown thing to compress : $f"
        fi
    done
done

cd $OLD_PWD

# move  %{libdir}/afs-stuff to %{libdir}/openafs
mv $RPM_BUILD_ROOT/%{libdir}/afs/* $RPM_BUILD_ROOT/%{libdir}/openafs
rm -rf $RPM_BUILD_ROOT/%{libdir}/afs

#
# prepare some directories

mkdir -p $RPM_BUILD_ROOT/var/adm/fillup-templates
mkdir -p $RPM_BUILD_ROOT/%{vicecachedir}
mkdir -p $RPM_BUILD_ROOT/%{viceetcdir}
mkdir    $RPM_BUILD_ROOT/%{viceetcdir}/C
mkdir -p $RPM_BUILD_ROOT/%{afsconfdir}
mkdir -p $RPM_BUILD_ROOT/%{afslocaldir}
mkdir -p $RPM_BUILD_ROOT/afs
cp -a %{S:54} $RPM_BUILD_ROOT%{viceetcdir}/CellServDB
cp -a %{S:55} $RPM_BUILD_ROOT%{viceetcdir}/SuidCells
cp -a %{S:56} $RPM_BUILD_ROOT%{viceetcdir}/CellAlias
cp -a %{S:57} $RPM_BUILD_ROOT%{viceetcdir}/ThisCell
cp -a %{S:58} $RPM_BUILD_ROOT%{viceetcdir}/cacheinfo
cp -a src/afs/afszcm.cat $RPM_BUILD_ROOT/%{viceetcdir}/C
install -m 644 %{S:13} $RPM_BUILD_ROOT/var/adm/fillup-templates/sysconfig.openafs-client
install -m 644 %{S:14} $RPM_BUILD_ROOT/var/adm/fillup-templates/sysconfig.openafs-server

#
# general cleanup
#

# it's already in /usr/bin
rm -f $RPM_BUILD_ROOT/usr/sbin/kpwvalid
# we supposedly don't need this one on linux
rm -f $RPM_BUILD_ROOT/usr/sbin/rmtsysd
#
#
# remove unrequired installed packages
%if %{transarc_paths} 
rm  %{buildroot}/%{bindir}/pts \
    %{buildroot}/%{bindir}/bos \
    %{buildroot}/%{sbindir}/vos \
    %{buildroot}/%{sbindir}/kas \
    %{buildroot}/%{bindir}/tokens \
    %{buildroot}/%{bindir}/tokens.krb \
    %{buildroot}/%{bindir}/klog \
    %{buildroot}/%{bindir}/klog.krb \
    %{buildroot}/%{bindir}/fs \
    %{buildroot}/%{bindir}/udebug \
    %{buildroot}/%{bindir}/kpwvalid
%endif


#
# remove man-pages on wrong place
#
if [ -n "$RPM_BUILD_ROOT" ] ; then
	rm -rf $RPM_BUILD_ROOT/usr/man/
fi

#
# remove file-duplicates
#

# devel package
%if 0%{?fdupes} != 0
%fdupes -s $RPM_BUILD_ROOT/%{includedir}
%fdupes -s $RPM_BUILD_ROOT/%{libdir}/openafs
%fdupes -s $RPM_BUILD_ROOT/usr/src/kernel-modules/openafs
# kernel-sources
%fdupes -s $RPM_BUILD_ROOT/usr/src/kernel-modules
%endif

%clean
%if %{option_clean_buildroot}
if [ -n "$RPM_BUILD_ROOT" ] ; then
	[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT
fi
%endif

%post kernel-source
echo To install the kernel-module, perform following steps:
echo cd /usr/src/linux
echo make cloneconfig
echo make init
echo cd /usr/src/kernel-modules/openafs
echo [Edit the makefile to your needs.]
echo make
echo make install

%post client
/sbin/ldconfig
%{fillup_and_insserv -n openafs-client}

%preun client
%{stop_on_removal}

%postun client
%{insserv_cleanup}
/sbin/ldconfig

%post server
if [ $1 -gt 1 ];then
    echo not stopping maybe running services.
    echo You must restart the service to put the upgrade into effect.
else 
    echo Please check /etc/sysconfig/openafs-server
    echo and follow the instructions found on http://www.openafs.org to install an openafs-server. 
fi
%{fillup_and_insserv -n openafs-server}

%preun server
%{stop_on_removal}

%postun server
%{insserv_cleanup}

%postun devel
/sbin/ldconfig

%post devel
/sbin/ldconfig

%post authlibs
/sbin/ldconfig

%postun authlibs
/sbin/ldconfig

#
#	FILES
#

%files           
%defattr(-,root,root)
%{bindir}/afsmonitor
%{bindir}/afs_compile_et
%{bindir}/kpasswd.afs
%{bindir}/afs_scout
%{bindir}/sys
%{bindir}/translate_et
%{bindir}/xstat_cm_test
%{bindir}/xstat_fs_test
%{sbindir}/backup
%{sbindir}/butc
%{sbindir}/fms
%if %{transarc_paths}
 %{afsbindir}/kas
 %{afsbindir}/kdb
 %{afsbindir}/vos
 %if %{osd_support}
  %{afsbindir}/osd
  %{afsbindir}/afsio
 %endif
 %{afsbindir}/bos
 %{afssrvbindir}/pts
 %{afssrvbindir}/klog
 %{afssrvbindir}/klog.krb
 %{afssrvbindir}/fs
 %{afssrvbindir}/udebug
 %{afssrvsbindir}/kpwvalid
 %dir %{afssrvbindir}
 %dir %{usrafsdir}
%else
 %{bindir}/pts
 %{sbindir}/kas
 %{sbindir}/kdb
 %{sbindir}/vos
 %{sbindir}/bos
 %if %{osd_support}
  %{bindir}/osd
  %{bindir}/afsio
 %endif
 %{bindir}/klog
 %{bindir}/klog.krb
 %{bindir}/fs
 %{sbindir}/udebug
 %{bindir}/kpwvalid
%endif
%{sbindir}/read_tape
%{sbindir}/restorevol
%{sbindir}/rxdebug
%{sbindir}/uss
%{sbindir}/vsys
%attr(755,root,root) %{afslogsdir}
%dir %{viceetcdir}
%config(noreplace) %{viceetcdir}/CellServDB

%files    docs   
%defattr(-,root,root)
%doc %{mandir}/man1/*
%doc %{mandir}/man5/*
%doc %{mandir}/man8/*
%doc NEWS README*

%files client
%defattr(-,root,root)
 %{bindir}/cmdebug
 %{bindir}/unlog
 %{bindir}/klog.krb5
 %{bindir}/up
 %{sbindir}/afsd
 %{sbindir}/fstrace
 %{bindir}/pagsh
 %{bindir}/pagsh.krb	
%if %{transarc_paths}
 %{afsbindir}/ka-forwarder
 %{afssrvbindir}/tokens
 %{afssrvbindir}/tokens.krb
%else
 %{sbindir}/ka-forwarder
 %{bindir}/tokens
 %{bindir}/tokens.krb
%endif
%if %{build_pamlibs}
 %{pamdir}/pam_afs.krb.so.1
 %{pamdir}/pam_afs.krb.so
 %{pamdir}/pam_afs.so.1
 %{pamdir}/pam_afs.so
%endif
%if %{option_dontbuild_kdump} == 0
 %{sbindir}/kdump 
%endif
/etc/init.d/openafs-client
%dir %{viceetcdir}/C
%{viceetcdir}/C/afszcm.cat
%config(noreplace) %{viceetcdir}/SuidCells
%config(noreplace) %{viceetcdir}/CellAlias
%config(noreplace) %{viceetcdir}/ThisCell
%config(noreplace) %{viceetcdir}/cacheinfo
/usr/sbin/rcopenafs-client
/var/adm/fillup-templates/sysconfig.openafs-client
/%{vicecachedir}
%ghost /afs
# tools for DCE:
/usr/bin/dlog
/usr/bin/dpass
%{mandir}/man1/cmdebug.*
%{mandir}/man1/up.*
%{mandir}/man5/afs*
%{mandir}/man5/cacheinfo.*
%{mandir}/man8/afsd.*
%{mandir}/man5/CellAlias.*

%files server 
%defattr(-,root,root)
%config /etc/init.d/openafs-server
%{_sbindir}/rcopenafs-server
%dir %{viceetcdir}/server
/var/adm/fillup-templates/sysconfig.openafs-server
%attr(770,root,root) %dir %{afslocaldir}
%if %{osd_support}
 %{sbindir}/copyauth
%endif
%{sbindir}/voldump
%{bindir}/knfs
%if %{transarc_paths} == 1
 %if %{osd_support}
  %{afsbindir}/archive1
  %{afsbindir}/archiver
  %{afsbindir}/osddbserver
  %{afsbindir}/rxosd
  %{afsbindir}/wiper
 %endif
 %{afsbindir}/ptserver
 %{afsbindir}/kaserver
 %{afsbindir}/salvager
 %{afsbindir}/vlserver
 %{afsbindir}/fileserver
 %{afsbindir}/buserver
 %{afsbindir}/bosserver
 %{afsbindir}/upclient
 %{afsbindir}/upserver
 %{afsbindir}/volserver
 %{afsbindir}/prdb_check
 %{afsbindir}/kadb_check
 %{afsbindir}/localauth
 %{afsbindir}/volinfo
 %{afsbindir}/vldb_convert
 %{afsbindir}/vldb_check
 %{afsbindir}/bos_util
 %{afsbindir}/pt_util
 %if %{osd_support}
  %{afsbindir}/readabyte
  %{afsbindir}/osdmetadata
  %{afsbindir}/linkcounts
 %endif
%else
%dir %{libdir}/openafs
 %if %{osd_support}
  %{libdir}/openafs/archive1
  %{libdir}/openafs/archiver
  %{sbindir}/localauth
  %{libdir}/openafs/osddbserver
  %{libdir}/openafs/rxosd
  %{libdir}/openafs/wiper
 %endif
 %{libdir}/openafs/ptserver
 %{libdir}/openafs/kaserver
 %{libdir}/openafs/salvager
 %{libdir}/openafs/vlserver
 %{libdir}/openafs/fileserver
 %{libdir}/openafs/buserver
 %{libdir}/openafs/upclient
 %{libdir}/openafs/upserver
 %{libdir}/openafs/volserver
 %{sbindir}/bosserver
 %{sbindir}/kadb_check
 %{sbindir}/prdb_check
 %{sbindir}/volinfo
 %{sbindir}/vldb_convert
 %{sbindir}/vldb_check
 %{sbindir}/bos_util
 %{sbindir}/pt_util
 %if %{osd_support}
   %{libdir}/openafs/readabyte
   %{sbindir}/osdmetadata
   %{sbindir}/linkcounts
 %endif 
%endif

%files devel  
%defattr(-,root,root)
%if %{transarc_paths}
 %{includedir}
 %{afslibdir}
 %{libdir}/libdes.a
 %{libdir}/libjuafs.a
 %{libdir}/liblwp.a
 %{libdir}/librx.a
 %{libdir}/librxkad.a
 %{libdir}/librxstat.a
 %{libdir}/libuafs.a
 %{libdir}/libubik.a
%else
 %{includedir}
 %dir %{libdir}/openafs
 %{libdir}/openafs/libacl.a
 %{libdir}/openafs/libafsadminutil.a
 %{libdir}/openafs/libafsint.a
 %{libdir}/openafs/libafsutil.a
 %{libdir}/openafs/libaudit.a
 %{libdir}/openafs/libauth.a
 %{libdir}/openafs/libauth.krb.a
 %{libdir}/openafs/libbos.a
 %{libdir}/openafs/libbosadmin.a
 %{libdir}/openafs/libbubasics.a
 %{libdir}/openafs/libbudb.a
 %{libdir}/openafs/libbutm.a
 %{libdir}/openafs/libbxdb.a
 %{libdir}/openafs/libcfgadmin.a
 %{libdir}/openafs/libclientadmin.a
 %{libdir}/openafs/libcmd.a
 %{libdir}/openafs/libcom_err.a
 %{libdir}/openafs/libdes.a
 %{libdir}/openafs/libdir.a
 %{libdir}/openafs/libfsprobe.a
 %{libdir}/openafs/libgtx.a
 %{libdir}/openafs/libjuafs.a
 %{libdir}/openafs/libkasadmin.a
 %{libdir}/openafs/libkauth.a
 %{libdir}/openafs/libkauth.krb.a
 %{libdir}/openafs/liblwp.a
 %{libdir}/openafs/libnull.a
 %{libdir}/openafs/libprocmgmt.a
 %{libdir}/openafs/libprot.a
 %{libdir}/openafs/libptsadmin.a
 %{libdir}/openafs/librx.a
 %{libdir}/openafs/librxkad.a
 %{libdir}/openafs/librxstat.a
 %{libdir}/openafs/libsys.a
 %{libdir}/openafs/libuafs.a
 %{libdir}/openafs/libubik.a
 %{libdir}/openafs/libusd.a
 %{libdir}/openafs/libvldb.a
 %{libdir}/openafs/libvlib.a
 %{libdir}/openafs/libvolser.a
 %{libdir}/openafs/libvosadmin.a
 %{libdir}/openafs/libxstat_cm.a
 %{libdir}/openafs/libxstat_fs.a
 %{libdir}/openafs/util.a
 %{libdir}/openafs/vlib.a
%endif
%{bindir}/livesys
%{bindir}/rxgen

%files    kernel-source 
%defattr(-,root,root)
%dir /usr/src/kernel-modules
%dir /usr/src/kernel-modules/openafs
/usr/src/kernel-modules/openafs/*

%if %{option_heimdal}
%files krb5-heimdal
%else 
%files krb5-mit
%endif
%defattr(-,root,root)
%{bindir}/aklog
%if %{transarc_paths}
 %{afssrvbindir}/asetkey
%else
 %{sbindir}/asetkey
%endif
%{mandir}/man1/aklog.*
%{mandir}/man8/asetkey.*


%if %{build_authlibs}
%files authlibs
%defattr(-,root,root)
%{libdir}/libafsauthent.so.*
%{libdir}/libafsrpc.so.*
%{libdir}/libafssetpag.so.*

%files authlibs-devel
%defattr(-,root,root)
%if %{transarc_paths}
%{libdir}/libafsauthent.a
%{libdir}/libafsauthent_pic.a
%{libdir}/libafsrpc.a
%{libdir}/libafsrpc_pic.a
%else
%{libdir}/openafs/libafsauthent.a
%{libdir}/openafs/libafsauthent_pic.a
%{libdir}/openafs/libafsrpc.a
%{libdir}/openafs/libafsrpc_pic.a
%endif
%{libdir}/libafsauthent.so
%{libdir}/libafsrpc.so
%{libdir}/libafssetpag.so
%endif

%if %{build_modules}
%if 0%{?sles_version} == 9
%files    KMP
%defattr(-,root,root)
/lib/modules/
%endif
%endif

#
#	CHANGELOG
#

%changelog
* Wed Jan 25 2006 mls@suse.de
- converted neededforbuild to BuildRequires
* Mon Jan 23 2006 nadvornik@suse.cz
- fixed kernel module to compile
* Wed Jan 11 2006 mge@suse.de
- add openafs.SuidCells and openafs.CellServDB
- cleanup SPEC-file(s)
- finally adopt
  sysconfig.transarcmode.openafs-client
  rc.transarcmode.afs-server
  rc.transarcmode.afs-client
  to transarc mode; and fix a small typo in
  rc.defaultmode.afs-client
* Fri Jan  6 2006 mge@suse.de
- set "%%defattr(-,root,root)" for transarcmode-file-lists
- fix lib64 build problem in transarcmode
* Thu Jan  5 2006 mge@suse.de
- introduce transarc-mode and default-mode
- introduce "options"
* Thu Dec 29 2005 mge@suse.de
- build for SLES 9
- with heimdal krb5 support
- enable-largefile-fileserver
* Wed Dec 21 2005 nadvornik@suse.cz
- updated to 1.4.0
- fixed dangerous compiler warnings
* Mon Oct 31 2005 dmueller@suse.de
- don't build as root
* Fri Aug 26 2005 nadvornik@suse.cz
- fixed kernel module to build
- fixed sysconfig file name
* Thu Jul 14 2005 nadvornik@suse.cz
- updated to 1.3.85
- used LSB conforming init script names
* Tue Jul  5 2005 hare@suse.de
- Update for linux 2.6.13.
* Thu May 12 2005 nadvornik@suse.cz
- gcc4 fixes in kernel module
* Tue Apr 12 2005 nadvornik@suse.cz
- fixed to compile with gcc4
* Wed Feb 23 2005 nadvornik@suse.cz
- fixed memory leaks and 64bit fixes backported from 1.3.79
- updated README.SUSE
* Thu Feb  3 2005 nadvornik@suse.cz
- updated to 1.3.78
* Mon Jan 31 2005 nadvornik@suse.cz
- fixed afs.h to be usable from userspace [#50283]
* Tue Jan 25 2005 nadvornik@suse.cz
- updated to latest snapshot
* Wed Sep 15 2004 nadvornik@suse.cz
- added requres: kernel-nongpl [#45167]
- fixed kernel module oops [#44618]
* Wed Aug 11 2004 nadvornik@suse.cz
- use kernel module from openafs 1.3.70 to support kernel 2.6
* Mon Mar  8 2004 nadvornik@suse.cz
- updated to 1.2.11
- added note that client for kernel 2.6 is not available
* Tue Jan 20 2004 ro@suse.de
- added pam-devel to neededforbuild
* Sat Dec 13 2003 meissner@suse.de
- Added hack if no MTU came from userspace.
- Removed superflous ppc64 patch part.
* Thu Dec 11 2003 meissner@suse.de
- ppc64 port added (status: no longer crashes, talks to the network,
  but not successfully).
- Change headerfiles to make it possible to do a ppc -> ppc64 crosscompile.
* Mon Oct  6 2003 olh@suse.de
- build with -fPIC on ppc32
* Tue Sep 16 2003 nadvornik@suse.cz
- patch from cvs to use AllocLargeSpace for struct osi_file to prevent
  oopses with some kernel configurations
* Thu Sep 11 2003 nadvornik@suse.cz
- added option DYNROOT to sysconfig and enabled it by default [#27205]
* Wed Sep 10 2003 nadvornik@suse.cz
- added cleanup before module build [#29649]
* Tue Sep  9 2003 nadvornik@suse.cz
- fixed possible segfault
* Thu Sep  4 2003 nadvornik@suse.cz
- set permissions of /var/lib/openafs to 700
- README.SuSE fixes
* Thu Aug 28 2003 nadvornik@suse.cz
- use ghost for /afs, the directory is created by init-script
- fixed README.SuSE
* Thu Aug 21 2003 nadvornik@suse.cz
- moved all static libraries to /usr/lib/afs, fixes conflict with libdes
- used default value for THIS_CELL_SERVER_NAME
- removed old patches
* Tue Aug 12 2003 nadvornik@suse.cz
- fixed a bug in init script
* Mon Aug 11 2003 nadvornik@suse.cz
- updated to final 1.2.10
* Wed Jul 30 2003 nadvornik@suse.cz
- updated to 1.2.10-rc4
- do not destroy CellServDB even if REGENERATE_CELL_INFO=yes
- fixed to compile on x86_64
* Wed Jul 30 2003 sf@suse.de
-  use %%_lib where it was missing
* Wed Jul  9 2003 nadvornik@suse.cz
- fixed conflicts in filelist
* Fri Jun 20 2003 nadvornik@suse.cz
- improved init scripts
* Thu Jun 19 2003 nadvornik@suse.cz
- added README.SuSE
- fixed init scripts [#27426]
- installed man pages
* Thu Jun 12 2003 poeml@suse.de
- add /usr/src/kernel-modules to the file list
* Wed Jun  4 2003 schwab@suse.de
- Fix SMP configuration detection.
* Wed May 14 2003 poeml@suse.de
- rework filelists:
  - package/remove unpackaged files
  - move some files into the server & client subpackages
  - use %%defattr
- fix deprecated tail -1 syntax (fixes building the kernel module)
* Mon May 12 2003 nadvornik@suse.cz
- updated to 1.2.9
- added DATA_ENCRYPTION option to sysconfig
* Mon Mar 10 2003 poeml@suse.de
- x86_64: add -lresolv, -fPIC
- fix lib path on all 64 bit platforms
* Thu Mar  6 2003 nadvornik@suse.cz
- added sysconfig metadata
* Mon Feb 24 2003 nadvornik@suse.cz
- added dirs /afs, /etc/openafs, /var/lib/openafs to filelist
* Sun Feb 16 2003 olh@suse.de
- workaround broken -lresolv detection, lib64 fixes
* Wed Feb 12 2003 nadvornik@suse.cz
- fixed multiline strings in kernel module
* Fri Jan 24 2003 nadvornik@suse.cz
- updated to 1.2.8
- improved init script
* Fri Nov 29 2002 nadvornik@suse.cz
- included errno.h
- fixed multiline strings
* Fri Nov 22 2002 nadvornik@suse.cz
- first version of init scripts
* Wed Nov 20 2002 poeml@suse.de
- initial draft of a package. Lots of stuff missing, like init
  scripts, or the kerberos 5 migration toolkit.
